#include "ZcosmosBD.h"

          implicit none

#include  "Zptcl.h"
#include  "Zcode.h"
#include  "Zevhnv.h"
#include  "Zevhnp.h"
#include  "Zmanagerp.h"

          integer nmax
          parameter (nmax =5000)   ! # of max ptcls supposed to be generated
          record /ptcl/ pj, a(nmax), tg, cmsptcl
c
          integer k,  ntp, j, nevent, nuccharge, icon, ia, iz
          integer kin
          real*8 x, y, eta, u
          real*8 sumx, sumy, sumz, sume, energy
          real pt, ptx, pty, pti
          character*120  msg
          logical lroots
c          integer l
c
          record /fmom/ rest

          rest.p(1) = 0.
          rest.p(2) = 0.
          rest.p(3) = 0.
          rest.p(4) = 0.

          IntModel = 'int1'
          Cepic0 = .33
          Elund = 4.99
          Elund2 = 4.99
          Elund3=4.99
          write (ErrorOut, *)' enter Cepic0 Elund, Elund2, Elund3'
          read(*,*) Cepic0, Elund, Elund2, Elund3

      if(IntModel .eq. 'int1') then
c           for Lund init.
         call haddenC
         call chanwnC
      elseif(IntModel .eq. 'int2') then
c         Gheisha; init. Gheisha cannot use hadrin/nucrin in Cosmos
         call gpart
         call gheini
      else
         write(msg, *) 'IntModel=', IntModel,' not supported'
         call cerrorMsg(msg, 0)
      endif

          msg = 'hA collisions; csm is that for hp col.'
          call cerrorMsg(msg, 1)
          msg =
     *    ' Enter 1) Root S flag(t/f), 2) # of events, 3) Energy(GeV)'
     *     //', 4) incident  code & charge 6) target a,z, 8)SucPw'
          call cerrorMsg(msg, 1)
          read(*, *) lroots, nevent, energy, kin, nuccharge, 
     *      ia, iz, SucPw
c
          write(*, *)
     *    '# hA collisons.  roots flag=', lroots, ' E(GeV)=', energy


          write(*, *)
     *    '# events=', nevent,  ' inc=',kin, ' c=',nuccharge
          write(*, *) '# target A,Z=', ia, iz,'  SucPw=',SucPw
          write(*, *) '# x, y, eta, pt, code, charge, multi pti'
c
cc             make incident nucleon
          call cmkptc(kin, regptcl, nuccharge,   pj)
cc      
c             make nuclon target (not for collision)
          call cmkptc(knuc, regptcl, 1, tg)
          tg.fm = rest
          tg.fm.p(4) = tg.mass

          if(lroots) then
             energy = ( energy**2 - pj.mass**2 - tg.mass**2)
     *                /2/tg.mass
          endif
          pj.fm.p(1) =0.
          pj.fm.p(2) =0.
          pj.fm.p(4) = energy
          pj.fm.p(3) = sqrt(pj.fm.p(4)**2-pj.mass**2)
c              form cms; this is for comparison with pp data
          call cgeqm(pj, tg, cmsptcl, icon)
c
          call rndc(u)
          do k=1, nevent
             call chAcol(pj, ia, iz, a, ntp)
             sumx = 0.
             do j=1, ntp
                x = a(j).fm.p(4) / pj.fm.p(4)
                sumx = sumx + x
                sumy =0.
                sumz =0.
                sume =0.
c                      boost to cms                
                call cbst1(j, cmsptcl,  a(j), a(j))
                call cyeta(a(j), y, eta)
                ptx = sngl( a(j).fm.p(1) )
                pty = sngl( a(j).fm.p(2) )
                pt = sqrt(a(j).fm.p(1)**2 + a(j).fm.p(2)**2)
                pti = 1./pt
                write(*, *) sngl(x), sngl(y), sngl(eta), pt, 
     *          a(j).code, a(j).charge,  ntp, pti, k
c                write(*,  *) ptx, pty
             enddo
c             write(*, *) sumx
          enddo   
        end




